// PropPage2.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "PropPage2.h"
#include "Database.h"
#include "CeDB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropPage2 property page

IMPLEMENT_DYNCREATE(CPropPage2, CPropertyPage)

CPropPage2::CPropPage2() : CPropertyPage(CPropPage2::IDD)
{
	// Initialite MFC gui values with default values
	// _RO stands for read only edit boxes.

	//{{AFX_DATA_INIT(CPropPage2)
	m_nHour_RO = 0;
	m_nMinute_RO = 0;
	m_fRating_RO = 0.0f;
	m_strTitle_RO = _T("");
	m_strDesc_RO = _T("");
	//}}AFX_DATA_INIT
}

CPropPage2::~CPropPage2()
{
}

void CPropPage2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropPage2)
	DDX_Text(pDX, IDE_RO_HOUR, m_nHour_RO);
	DDV_MinMaxInt(pDX, m_nHour_RO, 0, 12);
	DDX_Text(pDX, IDE_RO_MINUTE, m_nMinute_RO);
	DDV_MinMaxInt(pDX, m_nMinute_RO, 0, 59);
	DDX_Text(pDX, IDE_RO_RATING, m_fRating_RO);
	DDV_MinMaxFloat(pDX, m_fRating_RO, 0.f, 10.f);
	DDX_Text(pDX, IDE_RO_TITLE, m_strTitle_RO);
	DDV_MaxChars(pDX, m_strTitle_RO, 256);
	DDX_Text(pDX, IDE_RO_DESC, m_strDesc_RO);
	DDV_MaxChars(pDX, m_strDesc_RO, 1024);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropPage2, CPropertyPage)
	//{{AFX_MSG_MAP(CPropPage2)
	ON_BN_CLICKED(IDB_NEXTMOVIE, OnNextmovie)
	ON_BN_CLICKED(IDB_PREVMOVIE, OnPrevmovie)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropPage2 message handlers

BOOL CPropPage2::OnSetActive() 
{
	CCeDBApp *pCeDBApp = (CCeDBApp *)AfxGetApp();
	if(pCeDBApp->m_nItem >= 0)
	{
		// Set the currently selected DB pointer with the selection variable
		bool bResult = g_DB.SeekDB(CEDB_SEEK_BEGINNING, pCeDBApp->m_nItem);
		ASSERT(bResult);

		// Update GUI with currently selected record
		DisplayCurrentRecord();
	}
	else	// Set MFC temp variables to the defaults
	{
		m_nHour_RO = 0;
		m_nMinute_RO = 0;
		m_fRating_RO = 0.0f;
		m_strTitle_RO = _T("");
		m_strDesc_RO = _T("");

		// Allow MFC to update the GUI
		UpdateData(FALSE);
	}

	return CPropertyPage::OnSetActive();
}

void CPropPage2::OnPrevmovie() 
{
	// Decrement the currently selected DB pointer
	bool bResult = g_DB.SeekDB(CEDB_SEEK_CURRENT, -1);

	// Decrement selection variable
	if(bResult)
	{
		CCeDBApp *pCeDBApp = (CCeDBApp *)AfxGetApp();
		pCeDBApp->m_nItem--;

		// Update GUI with currently selected record
		DisplayCurrentRecord();
	}
}

void CPropPage2::OnNextmovie() 
{
	// Increment the currently selected DB pointer
	bool bResult = g_DB.SeekDB(CEDB_SEEK_CURRENT, 1);

	// Increment selection variable
	if(bResult)
	{
		CCeDBApp *pCeDBApp = (CCeDBApp *)AfxGetApp();
		pCeDBApp->m_nItem++;

		// Update GUI with currently selected record
		DisplayCurrentRecord();
	}
}

// Update GUI with currently selected record
void CPropPage2::DisplayCurrentRecord(void)
{
	CRecord record;
	g_DB.ReadRecord(record);

	// Copy record values into MFC GUI temporary variables
	m_strTitle_RO = record.m_strTitle;
	m_strDesc_RO = record.m_strDesc;
	m_nHour_RO = record.m_nHour;
	m_nMinute_RO = record.m_nMinute;
	m_fRating_RO = record.m_fRating;

	// Allow MFC to update the GUI
	UpdateData(FALSE);
}
