// PropPage3.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "PropPage3.h"
#include "Database.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropPage3 property page

IMPLEMENT_DYNCREATE(CPropPage3, CPropertyPage)

CPropPage3::CPropPage3() : CPropertyPage(CPropPage3::IDD)
{
	//{{AFX_DATA_INIT(CPropPage3)
	m_nHour = 0;
	m_nMinute = 0;
	m_strTitle = _T("");
	m_strDesc = _T("");
	m_fRating = 0.0f;
	//}}AFX_DATA_INIT
}

CPropPage3::~CPropPage3()
{
}

void CPropPage3::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropPage3)
	DDX_Control(pDX, IDS_RATING, m_sRating);
	DDX_Text(pDX, IDE_HOUR, m_nHour);
	DDV_MinMaxInt(pDX, m_nHour, 0, 12);
	DDX_Text(pDX, IDE_MINUTE, m_nMinute);
	DDV_MinMaxInt(pDX, m_nMinute, 0, 59);
	DDX_Text(pDX, IDE_TITLE, m_strTitle);
	DDV_MaxChars(pDX, m_strTitle, 256);
	DDX_Text(pDX, IDE_DESC, m_strDesc);
	DDV_MaxChars(pDX, m_strDesc, 1024);
	DDX_Text(pDX, IDE_RATING, m_fRating);
	DDV_MinMaxFloat(pDX, m_fRating, 0.f, 10.f);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropPage3, CPropertyPage)
	//{{AFX_MSG_MAP(CPropPage3)
	ON_BN_CLICKED(IDB_ADDMOVIE, OnAddmovie)
	ON_BN_CLICKED(IDB_CLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropPage3 message handlers

// Adds a record to the database
void CPropPage3::OnAddmovie() 
{
	// If data is not validated by MFC, have user revise.
	if(!UpdateData(TRUE))
		return;

	// Copy records from GUI variables to record structure
	CRecord record;
	record.m_strTitle = m_strTitle;
	record.m_strDesc = m_strDesc;
	record.m_nHour = m_nHour;
	record.m_nMinute = m_nMinute;
	record.m_fRating = m_fRating;
	
	// Add record to database
	bool bResult = g_DB.AddRecord(record);			
	ASSERT(bResult);

	// Beep for a successful addition
	MessageBeep(0xFFFFFFFF);

	// Clear fields
	OnClear();
}

// Clear all the fields on the current dialog box
void CPropPage3::OnClear() 
{
	m_nHour = 0;
	m_nMinute = 0;
	m_strTitle = _T("");
	m_strDesc = _T("");
	m_fRating = 0;
	UpdateData(FALSE);
}


BOOL CPropPage3::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_sRating.SetRange(0, 10);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
